dnl dancer-modules.m4
dnl This file is copyright (C) 2001 Andrew Suffield
dnl                                  <asuffield@users.sourceforge.net>
dnl
dnl This program is free software; you can redistribute it and/or modify
dnl it under the terms of the GNU General Public License as published by
dnl the Free Software Foundation; either version 2 of the License, or
dnl (at your option) any later version.
dnl
dnl This program is distributed in the hope that it will be useful,
dnl but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
dnl GNU General Public License for more details.
dnl
dnl You should have received a copy of the GNU General Public License
dnl along with this program; if not, write to the Free Software
dnl Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA

AC_DEFUN(DANCER_MODULES,[
AC_ARG_ENABLE(shared-modules,
[  --enable-shared-modules Support runtime loading of modules ],

[case "$enableval" in
	yes)	build_shared_modules=yes ;;
	no)	build_shared_modules=no ;;
	*)	build_shared_modules=yes ;;
esac],
[
dnl If we don't have an option specified, assume shared and run the setup
AC_ENABLE_SHARED(yes)
AC_ENABLE_STATIC(no)
AC_LIBTOOL_SETUP
build_shared_modules=$enable_shared
])

if test "$build_shared_modules" = "no"; then
	AC_DEFINE(STATIC_MODULES,1,Link the modules in statically)
        dnl Activate libtool static module support by default
        AC_ENABLE_SHARED(no)
        dnl And deactivate shared module support
        AC_ENABLE_STATIC(yes)
else
        dnl We're using ltdl to load modules
        ltdl_ldflags=""
        AC_CHECK_LIB(ltdl, lt_dlinit,
[ltdl_ldflags="-lltdl"
AC_DEFINE(HAVE_LTDL, 1, [libltdl is available])
])
        AC_SUBST(ltdl_ldflags)

        dnl And we use libdl as a fallback position
        dl_ldflags=""
        AC_CHECK_LIB(dl, dlopen, dl_ldflags="-ldl", AC_MSG_ERROR(**
libdl could not be found - try running configure with --disable-shared-modules))
        AC_SUBST(dl_ldflags)

        dnl Activate libtool shared module support by default
        AC_ENABLE_SHARED(yes)
        dnl And deactivate static module support
        AC_ENABLE_STATIC(no)
fi

AM_CONDITIONAL(SHARED_MODULES, test x$build_shared_modules = xyes)

if test "$build_shared_modules" != "yes"
then
        AC_MSG_ERROR(Static linking of modules is not currently supported)
fi
])