/************************************************************************
 *   This is part of Dancer, a text relay daemon
 *   Copyright (C) 2002 Andrew Suffield <asuffield@users.sourceforge.net>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

#ifdef CONFIG_H
#else
#define CONFIG_H
#include <dancerd/setup.h>
/* We want this included everywhere anyway, but it needs to come in
 * before the #pragma GCC poison directive below
 */
#include <sys/types.h>
/* We'll include this everywhere in the name of simplicity */
#include <stdbool.h>

/** \file config.h
 * \brief Global definitions acquired from configure
 * \ingroup main
 * Every compilation unit in dancer must include <dancerd/config.h>,
 * without exception.
 *
 * Every header should include <dancerd/config.h>.
 */

#ifdef HAVE_ATTRIBUTE
#define printf_format_attribute(A,B) __attribute__((format(printf,A,B)))
#else
#define printf_format_attribute(A,B)
#endif

#define CONSTRUCTOR() \
 static void _dancer__init_(void) __attribute__((constructor)); \
 static void _dancer__init_(void)

#define DESTRUCTOR() \
 static void _dancer__fini_(void) __attribute__((destructor)); \
 static void _dancer__fini_(void)

#define min(A,B) ((A) < (B) ? (A) : (B))
#define max(A,B) ((A) > (B) ? (A) : (B))

#define _(X) gettext(X)
#define N_(X) gettext_noop(X)

#endif
