/************************************************************************
 *   This is part of Dancer, a text relay daemon
 *   Copyright (C) 2002 Andrew Suffield <asuffield@users.sourceforge.net>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

#ifdef EVENT_H
struct event;
#else
#define EVENT_H
#include <dancerd/config.h>

/** \file event.h
 * \brief Event signals
 */

/** \defgroup event Event signals
 * \ingroup main
 * A generic string-based event handling system. This can be used for
 * two unrelated modules to signal each other without knowing anything
 * about the others existance.  When an event is raised, all the
 * registered handlers will be called in the sequence they were
 * registered
 * 
 * @{
 */

struct event;

typedef void event_handler_func(struct event *);

void add_event_handler(struct event *, event_handler_func *);
void delete_event_handler(struct event *, event_handler_func *);
void raise_event(struct event *);
struct event *event(const char *);

/** @}
 */

#endif
