/************************************************************************
 *   This is part of Dancer, a text relay daemon
 *   Copyright (C) 2002 Andrew Suffield <asuffield@users.sourceforge.net>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

#ifdef PATHS_H
#else
#define PATHS_H
#include <dancerd/config.h>

/** \file paths.h
 * \brief Globally configured paths in the filesystem
 */

/** \defgroup paths Globally configured paths in the filesystem
 * \ingroup main
 * These variables define the paths that everything should use; no
 * filesystem accesses should be made that are not relative to one of
 * these paths. This may necessitate adding more paths later.
 *
 * @{
 */ 

extern const char *pidfile, *logfile, *module_dir;
extern const char *logdir, *statedir, *datadir, *localedir, *rundir, *confdir;

/* This may only be called from main.c */
extern void set_root(const char *);

/** @}
 */

#endif
