/************************************************************************
 *   This is part of Dancer, a text relay daemon
 *   Copyright (C) 2002 Andrew Suffield <asuffield@users.sourceforge.net>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

#ifdef VERSION_H
#else
#define VERSION_H
#include <dancerd/config.h>

/** \file version.h
 * \brief Global version strings
 */

/** \defgroup version Global version strings
 * \ingroup main
 * Stores the version strings associated with the currently running
 * main binary.
 *
 * Modules may have independant versions, although they must be
 * compiled against a specific version of the daemon.
 *
 * @{
 */
 
extern const char *dancer_version, *serial_number, *build_platform, *build_time;
extern const char *license[], *authors[];
extern int license_lines, authors_lines;

/** @}
 */

#endif
