/************************************************************************
 *   This is part of Dancer, a text relay daemon
 *   Copyright (C) 2002 Andrew Suffield <asuffield@users.sourceforge.net>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

#include <dancerd/config.h>
#include <dancerd/version.h>
#include <dancerd/ctor.h>

#include <stddef.h>

const char *dancer_version = VERSION;
const char *serial_number = SERIAL;
const char *build_platform = BUILD_UNAME;
const char *build_time = BUILD_TIME;

const char *license[] = 
  {
#include "license.tab"    
    NULL
  };

const char *authors[] =
  {
#include "authors.tab"
    NULL
  };

int license_lines = 0;
int authors_lines = 0;

GLOBAL_CONSTRUCTOR(main_version, NULL)
{
  const char **c;
  for (c = license; *c; c++)
    license_lines++;
  for (c = authors; *c; c++)
    authors_lines++;
}
