/************************************************************************
 *   This is part of Dancer, a text relay daemon
 *   Copyright (C) 2002 Andrew Suffield <asuffield@users.sourceforge.net>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

#ifdef DB_INTERNAL_H
#else
#define DB_INTERNAL_H
#include <dancerd/config.h>
#include <dancerd/database/database.h>

#include <db.h>

struct database
{
  char *namespace, *name;
  int dup;
  DB *db, *temp_db;
  associated_key_callback *associated_key_callback;
};

struct database_cursor
{
  DBC *cursor;
  struct database *db;
};

struct database_transaction
{
  DB_TXN *txn;
};

typedef int compare_func(DB *, const DBT *, const DBT *);
typedef size_t prefix_func(DB *, const DBT *, const DBT *);

extern DB *open_db(const char *, const char *, DB_TXN *, int, compare_func *, compare_func *, prefix_func *);
extern void close_db(DB *);
extern DB_TXN *begin_transaction(void);
extern void abort_transaction(DB_TXN *txn);
extern int commit_transaction(DB_TXN *txn);

extern void set_errpfx(const char *prefix);

#endif
