/************************************************************************
 *   This is part of Dancer, a text relay daemon
 *   Copyright (C) 2002 Andrew Suffield <asuffield@users.sourceforge.net>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

#ifdef ROUTER_ROUTER_H
#else
#define ROUTER_ROUTER_H

#include <dancerd/config.h>
#include <dancerd/llist.h>

#include "node.h"

/** \defgroup router Message router
 *
 * The protocol layer encodes/decodes messages from sessions, and
 * passes them up to interested modules.
 *
 * @{
 */

extern struct llist *routers;
extern struct llist *global_nodes;
extern struct node *me;

extern int router_attribute;

/** @}
 */

#endif
