/************************************************************************
 *   This is part of Dancer, a text relay daemon
 *   Copyright (C) 2002 Andrew Suffield <asuffield@users.sourceforge.net>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

spawn "main.hashtable" modules => "test.main.hashtable";
open pipe cmdpipe "main.hashtable" "test.main.hashtable";

write pipe NEW_HASHTABLE;
write pipe LOOKUP alpha;
read pipe (null);
write pipe DELETE alpha;
write pipe INSERT alpha one;
write pipe INSERT beta two;
write pipe INSERT gamma three;
write pipe INSERT delta four;
write pipe LOOKUP alpha;
read pipe one;
write pipe LOOKUP beta;
read pipe two;
write pipe LOOKUP gamma;
read pipe three;
write pipe LOOKUP delta;
read pipe four;
write pipe LOOKUP epsilon;
read pipe (null);
write pipe INSERT alpha five;
write pipe INSERT beta six;
write pipe LOOKUP alpha;
read pipe five;
write pipe LOOKUP beta;
read pipe six;
write pipe LOOKUP gamma;
read pipe three;
write pipe LOOKUP delta;
read pipe four;
write pipe LOOKUP epsilon;
read pipe (null);
write pipe DELETE beta;
write pipe LOOKUP alpha;
read pipe five;
write pipe LOOKUP beta;
read pipe (null);
write pipe LOOKUP gamma;
read pipe three;
write pipe LOOKUP delta;
read pipe four;
write pipe LOOKUP epsilon;
read pipe (null);
write pipe DESTROY_HASHTABLE;

/* Now, generate some collisions
 *
 * Being prefix-oriented, the hash_ascii algorithm will collide all
 * these similarly-prefixed things
 */
write pipe NEW_HASHTABLE;
write pipe INSERT __________alpha 11;
write pipe INSERT __________beta 22;
write pipe INSERT __________gamma 33;
write pipe INSERT __________delta 44;
write pipe INSERT __________epsilon 55;
write pipe LOOKUP __________alpha;
read pipe 11;
write pipe LOOKUP __________beta;
read pipe 22;
write pipe LOOKUP __________gamma;
read pipe 33;
write pipe LOOKUP __________delta;
read pipe 44;
write pipe LOOKUP __________epsilon;
read pipe 55;
write pipe DELETE __________alpha;
write pipe LOOKUP __________alpha;
read pipe (null);
write pipe LOOKUP __________beta;
read pipe 22;
write pipe LOOKUP __________gamma;
read pipe 33;
write pipe LOOKUP __________delta;
read pipe 44;
write pipe LOOKUP __________epsilon;
read pipe 55;
write pipe DELETE __________alpha;
write pipe LOOKUP __________alpha;
read pipe (null);
write pipe LOOKUP __________beta;
read pipe 22;
write pipe LOOKUP __________gamma;
read pipe 33;
write pipe LOOKUP __________delta;
read pipe 44;
write pipe LOOKUP __________epsilon;
read pipe 55;
write pipe DELETE __________epsilon;
write pipe LOOKUP __________alpha;
read pipe (null);
write pipe LOOKUP __________beta;
read pipe 22;
write pipe LOOKUP __________gamma;
read pipe 33;
write pipe LOOKUP __________delta;
read pipe 44;
write pipe LOOKUP __________epsilon;
read pipe (null);
write pipe DELETE __________epsilon;
write pipe LOOKUP __________alpha;
read pipe (null);
write pipe LOOKUP __________beta;
read pipe 22;
write pipe LOOKUP __________gamma;
read pipe 33;
write pipe LOOKUP __________delta;
read pipe 44;
write pipe LOOKUP __________epsilon;
read pipe (null);
write pipe DELETE __________gamma;
write pipe LOOKUP __________alpha;
read pipe (null);
write pipe LOOKUP __________beta;
read pipe 22;
write pipe LOOKUP __________gamma;
read pipe (null);
write pipe LOOKUP __________delta;
read pipe 44;
write pipe LOOKUP __________epsilon;
read pipe (null);
write pipe DELETE __________gamma;
write pipe LOOKUP __________alpha;
read pipe (null);
write pipe LOOKUP __________beta;
read pipe 22;
write pipe LOOKUP __________gamma;
read pipe (null);
write pipe LOOKUP __________delta;
read pipe 44;
write pipe LOOKUP __________epsilon;
read pipe (null);
write pipe DESTROY_HASHTABLE;

kill "main.hashtable";
