/************************************************************************
 *   This is part of Dancer, a text relay daemon
 *   Copyright (C) 2002 Andrew Suffield <asuffield@users.sourceforge.net>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

/* Start with no modules */
spawn "main.startup";
kill "main.startup";

/* Note that we can't use 'spawn "foo" modules =>' here, because it
 * checks that the module loaded ok
 */

/* Start with null module */
spawn "main.startup" args => '-mbasic.null';
open log log "main.startup";
read log core [info]: Trying to load module basic.null;
read log core [info]: Successfully loaded module basic.null;
kill "main.startup";
read log core [info]: Unloaded module basic.null;
close log;

/* Start with invalid module */
spawn "main.startup" args => '-minvalid';
open log log "main.startup";
read log core [info]: Trying to load module invalid;
read log core [error]: Couldn't load module invalid: No such file or directory;
kill "main.startup";
close log;

/* Start with incorrectly named module */
preinstall "main.startup";
system "cp" 
       (spawn_path "main.startup") . "/lib/dancerd/basic.null.so"
       (spawn_path "main.startup") . "/lib/dancerd/basic.misnamed.so";
system "cp" 
       (spawn_path "main.startup") . "/lib/dancerd/basic.null.la"
       (spawn_path "main.startup") . "/lib/dancerd/basic.misnamed.la";
spawn "main.startup" args => '-mbasic.misnamed';
open log log "main.startup";
read log core [info]: Trying to load module basic.misnamed;
read log core [error]: Loaded module basic.misnamed, but its embedded name is basic.null, aborting;
kill "main.startup";
