# Copyright (C) 2002 Andrew Suffield <asuffield@users.sourceforge.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA

use strict;
use 5.006;
use warnings;
use DejaPerl qw/:framework/;
use Dancer::CmdPipe;
use Dancer::Spawn;
use Dancer::Spawn;

my $dancer = new Dancer::Spawn "main.strip_spaces";
$dancer->install();
$dancer->start(modules => [qw/test.main/]);
my $pipe = new Dancer::CmdPipe $dancer, "main.strip_spaces", "test.main", sanity_checks => 0;

my %flip = ('>' => '<', '<' => '>', '==' => '==');

verbose "Starting test run...";

while (<DATA>)
  {
    chomp;
    my $stripped = $_;
    $stripped =~ s/^\s*//;
    $stripped =~ s/\s*$//;
    $pipe->check_cmd_value("STRIP_SPACES $_", $stripped, "strip spaces from '$_'");
  }

close DATA;

verbose "Finished test run";

$dancer->kill();

1;

__DATA__
foo

 foo
foo 
   foo
foo   
   foo   
