/************************************************************************
 *   This is part of Dancer, a text relay daemon
 *   Copyright (C) 2002 Andrew Suffield <asuffield@users.sourceforge.net>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

preinstall "rfc1459.system.auth";
put_config "rfc1459.system.auth" "router.name" "string" "router.";
put_config "rfc1459.system.auth" "router.real_name" "string" "Router";
put_config "rfc1459.system.auth" "protocol.max-unknown-send-queue" "integer" "4";
put_config "rfc1459.system.auth" "transport.classes" "string" "tclass1";
put_config "rfc1459.system.auth" "transport.classes.tclass1.transport" "string" "ipv4.tcp";
put_config "rfc1459.system.auth" "transport.classes.tclass1.bind_address" "integer" (eval 'unpack "I", v127.0.0.1');
put_config "rfc1459.system.auth" "transport.classes.tclass1.bind_port" "integer" (eval 'unpack "S", pack "n", 6543');
spawn "rfc1459.system.auth" modules => "database.db" "config.database" "transport" "protocol"
                                       "transport.ipv4.tcp" "protocol.rfc1459.client" "auth"
                                       "auth.password" "router";

open socket rfc1459 "127.0.0.1" 6543;
write socket USER x x x :Real name alpha;
write socket NICK alpha;
read socket :router. 001 alpha :Welcome to the Internet Relay Network alpha;
read socket :router. 002 alpha :Your host is *[*/0], running version 1.1.0-unreleased/protocol.rfc1459.client-1.0;
read socket :router. 399 alpha :This username has not been registered. Please register.;
write socket BEGINAUTH invalid alpha;
read socket :router. 052 alpha :Invalid method name;
write socket CANCELAUTH;
read socket :router. 052 alpha :Authentication cancelled;
write socket CANCELAUTH reason;
read socket :router. 052 alpha :Authentication cancelled;
write socket ACCEPTAUTH;
read socket :router. 052 alpha :Authentication cancelled;
write socket AUTHDATA;
read socket :router. 052 alpha :Authentication cancelled;

write socket REGISTER Real name alpha;
read socket :router. 399 alpha :Your username has been registered;
write socket SETCRED password foo;
read socket :router. 399 alpha :Credentials updated;

write socket QUIT;
eof socket;

open socket rfc1459 "127.0.0.1" 6543;
write socket USER x x x :Real name alpha;
write socket NICK alpha;
read socket :router. 001 alpha :Welcome to the Internet Relay Network alpha;
read socket :router. 002 alpha :Your host is *[*/0], running version 1.1.0-unreleased/protocol.rfc1459.client-1.0;
read socket :router. 399 alpha :This username has been registered. Please authenticate.;
write socket BEGINAUTH password alpha;
write socket AUTHDATA foo;
read socket :router. 051 alpha :Authentication accepted;
write socket QUIT;
eof socket;

open socket rfc1459 "127.0.0.1" 6543;
write socket USER x x x :Real name alpha;
write socket NICK alpha;
read socket :router. 001 alpha :Welcome to the Internet Relay Network alpha;
read socket :router. 002 alpha :Your host is *[*/0], running version 1.1.0-unreleased/protocol.rfc1459.client-1.0;
read socket :router. 399 alpha :This username has been registered. Please authenticate.;
write socket BEGINAUTH password alpha;
write socket AUTHDATA bar;
read socket :router. 052 alpha :Incorrect password;

/* It's cancelled, so you can't carry on and try again */
write socket AUTHDATA foo;
read socket :router. 052 alpha :Authentication cancelled;

/* But you can start over */
write socket BEGINAUTH password alpha;
write socket CANCELAUTH password alpha;
read socket :router. 052 alpha :Authentication cancelled;

write socket BEGINAUTH password alpha;
write socket AUTHDATA foo;
read socket :router. 051 alpha :Authentication accepted;

write socket QUIT;
eof socket;

kill "rfc1459.system.auth";
