/************************************************************************
 *   This is part of Dancer, a text relay daemon
 *   Copyright (C) 2002 Andrew Suffield <asuffield@users.sourceforge.net>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

preinstall "rfc1459.system.version";
put_config "rfc1459.system.version" "router.name" "string" "router.";
put_config "rfc1459.system.version" "router.real_name" "string" "Router";
put_config "rfc1459.system.version" "protocol.max-unknown-send-queue" "integer" "4";
put_config "rfc1459.system.version" "transport.classes" "string" "tclass1";
put_config "rfc1459.system.version" "transport.classes.tclass1.transport" "string" "ipv4.tcp";
put_config "rfc1459.system.version" "transport.classes.tclass1.bind_address" "integer" (eval 'unpack "I", v127.0.0.1');
put_config "rfc1459.system.version" "transport.classes.tclass1.bind_port" "integer" (eval 'unpack "S", pack "n", 6543');
spawn "rfc1459.system.version" modules => "database.db" "config.database" "transport" "protocol"
                                          "transport.ipv4.tcp" "protocol.rfc1459.client" "auth"
                                          "router";

open   socket rfc1459 "127.0.0.1" 6543;
write  socket USER x x x :Real name alpha;
write  socket NICK alpha;
read   socket :router. 001 alpha :Welcome to the Internet Relay Network alpha;
read   socket :router. 002 alpha :Your host is *[*/0], running version 1.1.0-unreleased/protocol.rfc1459.client-1.0;
read   socket :router. 399 alpha :This username has not been registered. Please register.;

write  socket VERSION;
readre socket :router\. 351 alpha dancerd-1\.1\.0-unreleased\([^\)]+\) router. :Dancer: a text relay daemon;

write  socket INFO;
read   socket :router. 371 alpha :This is dancer, a text relay daemon.;
readre socket (?::router\. 371 alpha :.*\r\n)*;
read   socket :router. 374 alpha :End of /INFO list;

write  socket LICENSE;
read   socket :router. 371 alpha :This is dancer, a text relay daemon.;
readre socket (?::router\. 371 alpha :.*\r\n)*;
read   socket :router. 374 alpha :End of /LICENSE list;

write  socket QUIT;
eof    socket;

kill "rfc1459.system.version";
