/************************************************************************
 *   This is part of Dancer, a text relay daemon
 *   Copyright (C) 2002 Andrew Suffield <asuffield@users.sourceforge.net>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

preinstall "rfc1459.system.whois";
put_config "rfc1459.system.whois" "router.name" "string" "router.";
put_config "rfc1459.system.whois" "router.real_name" "string" "Router";
put_config "rfc1459.system.whois" "protocol.max-unknown-send-queue" "integer" "4";
put_config "rfc1459.system.whois" "transport.classes" "string" "tclass1";
put_config "rfc1459.system.whois" "transport.classes.tclass1.transport" "string" "ipv4.tcp";
put_config "rfc1459.system.whois" "transport.classes.tclass1.bind_address" "integer" (eval 'unpack "I", v127.0.0.1');
put_config "rfc1459.system.whois" "transport.classes.tclass1.bind_port" "integer" (eval 'unpack "S", pack "n", 6543');
spawn "rfc1459.system.whois" modules => "database.db" "config.database" "transport" "protocol"
                                        "transport.ipv4.tcp" "protocol.rfc1459.client" "auth"
                                        "router";

open alpha rfc1459 "127.0.0.1" 6543;
write alpha USER x x x :Real name alpha;
write alpha NICK alpha;
read alpha :router. 001 alpha :Welcome to the Internet Relay Network alpha;
read alpha :router. 002 alpha :Your host is *[*/0], running version 1.1.0-unreleased/protocol.rfc1459.client-1.0;
read alpha :router. 399 alpha :This username has not been registered. Please register.;

open beta rfc1459 "127.0.0.1" 6543;
write beta USER x x x :Real name beta;
write beta NICK beta;
read beta :router. 001 beta :Welcome to the Internet Relay Network beta;
read beta :router. 002 beta :Your host is *[*/0], running version 1.1.0-unreleased/protocol.rfc1459.client-1.0;
read beta :router. 399 beta :This username has not been registered. Please register.;

write alpha WHOIS alpha;
read alpha :router. 311 alpha alpha alpha * * :Real name alpha;
read alpha :router. 318 alpha alpha :End of /WHOIS list;

write alpha WHOIS beta;
read alpha :router. 311 alpha beta beta * * :Real name beta;
read alpha :router. 318 alpha beta :End of /WHOIS list;

write beta WHOIS alpha;
read beta :router. 311 beta alpha alpha * * :Real name alpha;
read beta :router. 318 beta alpha :End of /WHOIS list;

write beta WHOIS beta;
read beta :router. 311 beta beta beta * * :Real name beta;
read beta :router. 318 beta beta :End of /WHOIS list;

write alpha WHOIS gamma;
read alpha :router. 401 alpha gamma :No such nick/channel;

write beta WHOIS gamma;
read beta :router. 401 beta gamma :No such nick/channel;

write alpha QUIT;
eof alpha;

write beta WHOIS alpha;
read beta :router. 401 beta alpha :No such nick/channel;

write beta QUIT;
eof beta;

kill "rfc1459.system.whois";
