/************************************************************************
 *   This is part of Dancer, a text relay daemon
 *   Copyright (C) 2002 Andrew Suffield <asuffield@users.sourceforge.net>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

preinstall "ipv4.tcp";
put_config "ipv4.tcp" "protocol.max-unknown-send-queue" "integer" "4";
put_config "ipv4.tcp" "transport.classes" "string" "tclass1";
put_config "ipv4.tcp" "transport.classes.tclass1.transport" "string" "ipv4.tcp";
put_config "ipv4.tcp" "transport.classes.tclass1.bind_address" "integer" (eval 'unpack "I", v127.0.0.1');
put_config "ipv4.tcp" "transport.classes.tclass1.bind_port" "integer" (eval 'unpack "S", pack "n", 6543');
spawn "ipv4.tcp" modules => "database.db" "config.database" "transport" "protocol"
                            "test.protocol" "transport.ipv4.tcp";

open proto cmdpipe "ipv4.tcp" "test.protocol";
write proto REGISTER_PROTOCOL;
write proto IDENTIFY_RESULT 1;

open socket socket "127.0.0.1" 6543;
write socket alpha;
read proto IDENTIFY: alpha;
read proto NEW_SESSION;
write proto NAME_SESSION 0;
read proto INIT_SESSION;
read proto READ_DATA: alpha;
write socket beta;
read proto READ_DATA: beta;
write socket gamma;
read proto READ_DATA: gamma;

write proto WRITE_DATA 0 iti;
readre socket iti;
write proto WRITE_DATA 0 ni;
readre socket ni;
write proto WRITE_DATA 0 san;
readre socket san;

close socket;
read proto CLOSE_SESSION;

listen socket socket "127.0.0.1" 6544;
write proto BEGIN_CONNECTION test ipv4.tcp tclass1 127.0.0.1:6544;
accept socket;
read proto CONNECTION_READY;
read proto NEW_OUTGOING_SESSION;
read proto READ_DATA: ;
write socket alpha;
read proto READ_DATA: alpha;
write socket beta;
read proto READ_DATA: beta;
write socket gamma;
read proto READ_DATA: gamma;
write proto WRITE_DATA 127.0.0.1:6544 iti;
readre socket iti;
write proto WRITE_DATA 127.0.0.1:6544 ni;
readre socket ni;
write proto WRITE_DATA 127.0.0.1:6544 san;
readre socket san;
close socket;
read proto CLOSE_SESSION;

kill "ipv4.tcp";
