# Copyright (C) 2002 Andrew Suffield <asuffield@users.sourceforge.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA

package Dancer::CmdScript::Expression::Assign;

use strict;
use 5.006;
use warnings;

BEGIN
  {
    use Exporter;
    our @ISA = qw/Exporter/;
    our $VERSION = "0.0.1";
    our @EXPORT = qw//;
    our @EXPORT_OK = qw//;
  }

sub new
  {
    my $class = shift;
    my ($line, $var, $expr) = @_;

    my $self = {
                line => $line,
                var => $var,
                expr => $expr,
               };
    bless $self, $class;
    return $self;
  }

sub interpolate
  {
    my $self = shift;
    my $interp = shift;
    $self->{expr}->interpolate($interp);
  }

sub optimise
  {
    my $self = shift;
    $self->{expr} = $self->{expr}->optimise();
    return $self;
  }

sub constant
  {
    return 0;
  }

sub eval
  {
    my $self = shift;
    my $script = shift;

    $script->variables()->{$self->{var}} = $self->{expr}->eval($script);
  }

1;
