# Copyright (C) 2002 Andrew Suffield <asuffield@users.sourceforge.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA

package Dancer::CmdScript::Expression::Atom;

use strict;
use 5.006;
use warnings;

BEGIN
  {
    use Exporter;
    our @ISA = qw/Exporter/;
    our $VERSION = "0.0.1";
    our @EXPORT = qw//;
    our @EXPORT_OK = qw//;
  }

sub new
  {
    my $class = shift;
    my ($line, $value) = @_;

    my $self = {
                line => $line,
                value => $value,
               };
    bless $self, $class;
    return $self;
  }

sub interpolate
  {
    return;
  }

sub optimise
  {
    my $self = shift;
    return $self;
  }

sub constant
  {
    return 1;
  }

sub eval
  {
    my $self = shift;
    my $script = shift;

    return $self->{value};
  }

package Dancer::CmdScript::Expression::Value;
our @ISA = qw/Dancer::CmdScript::Expression::Atom/;

package Dancer::CmdScript::Expression::Variable;
our @ISA = qw/Dancer::CmdScript::Expression::Atom/;

sub constant
  {
    return 0;
  }

sub eval
  {
    my $self = shift;
    my $script = shift;

    my $vars = $script->variables();
    die {line => $self->{line}, msg => "Undefined variable $self->{value}"} unless exists $vars->{$self->{value}};
    return $vars->{$self->{value}};
  }

1;
