# Copyright (C) 2002 Andrew Suffield <asuffield@users.sourceforge.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA

package Dancer::CmdScript::Function::Config;

use strict;
use 5.006;
use warnings;

use Dancer::CmdInterpreter;

BEGIN
  {
    use Exporter;
    our @ISA = qw/Exporter/;
    our $VERSION = "0.0.1";
    our @EXPORT = qw//;
    our @EXPORT_OK = qw//;
  }

sub get_config
  {
    my $script = shift;
    my $line = shift;
    my $name = shift;
    $name = $script->prefix() . $name->eval($script);
    die "Installation $name does not exist" unless $script->spawns()->{$name};
    $script->spawns()->{$name}->get_config(map {$_->eval($script)} @_);
  }

sub put_config
  {
    my $script = shift;
    my $line = shift;
    my $name = shift;
    $name = $script->prefix() . $name->eval($script);
    die "Installation $name does not exist" unless $script->spawns()->{$name};
    $script->spawns()->{$name}->put_config(map {$_->eval($script)} @_);
  }

sub delete_config
  {
    my $script = shift;
    my $line = shift;
    my $name = shift;
    $name = $script->prefix() . $name->eval($script);
    die "Installation $name does not exist" unless $script->spawns()->{$name};
    $script->spawns()->{$name}->delete_config(map {$_->eval($script)} @_);
  }

Dancer::CmdInterpreter::register_function('get_config', \&get_config);
Dancer::CmdInterpreter::register_function('put_config', \&put_config);
Dancer::CmdInterpreter::register_function('delete_config', \&delete_config);

1;
