/************************************************************************
 *   This is part of Dancer, a text relay daemon
 *   Copyright (C) 2002 Andrew Suffield <asuffield@users.sourceforge.net>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

#ifdef CMDPIPE_H

struct cmdpipe;

#else
#define CMDPIPE_H
#include <dancerd/config.h>
#include <dancerd/modules.h>

#include <sys/types.h>

struct cmdpipe;

typedef int cmdpipe_parse_func(char *, size_t);
typedef void cmdpipe_fail_func(void);

extern struct cmdpipe *setup_cmdpipe(struct module *, const char *, size_t, cmdpipe_parse_func *, cmdpipe_fail_func *);
extern void close_cmdpipe(struct cmdpipe *);
extern void write_output_buffer(struct cmdpipe *, const char *, size_t);
extern void print_output_buffer(struct cmdpipe *, const char *, ...);
extern void write_output_done(struct cmdpipe *);

struct parsed_args
{
  char *argv[16];
  size_t argl[16];
  size_t argc;
};

extern struct parsed_args *parse_cmdpipe_data(char *, size_t);

#endif
